.\" $NetBSD: ukyopon.4,v 1.7 2005/05/18 15:05:26 wiz Exp $
.\"
.\" Copyright (c) 2005 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by ITOH Yasufumi.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd May 18, 2005
.Dt UKYOPON 4
.Os
.Sh NAME
.Nm ukyopon
.Nd Kyocera AIR-EDGE PHONE support
.Sh SYNOPSIS
.Cd "ukyopon* at uhub?"
.Cd "ucom*    at ukyopon? portno ?"
.Pp
.In dev/usb/ukyopon.h
.Sh DESCRIPTION
The
.Nm
driver provides support for Kyocera AIR-EDGE PHONE AH-K3001V.
.Pp
Two units of this driver attach to an AIR-EDGE PHONE:
the modem port and the data transfer port.
The modem port is compatible to
.Xr umodem 4 ,
and can be used for dialup connections.
The data transfer port is for reading and writing internal storage
of AIR-EDGE PHONE.
.Pp
Both devices are accessed through the
.Xr ucom 4
driver which makes them behave like a
.Xr tty 4 .
.Pp
The manipulation of the internal storage is through external programs,
for example, the
.Pa pkgsrc/comms/kyopon
package.
.Sh IOCTLS
The following
.Xr ioctl 2
calls apply to the
.Nm
device:
.Pp
.Bl -tag -width XXXXXX
.It Dv UKYOPON_IDENTIFY Fa struct ukyopon_identify
Read, from the kernel, the identification information of the device,
useful to assure that the opened device node is
a modem or a data transfer port of
.Nm
device.
.Bd -literal
struct ukyopon_identify {
	char	ui_name[16];		/* driver name */

	int	ui_busno;		/* usb bus number */
	uint8_t	ui_address;		/* device address */

	enum ukyopon_model {
		UKYOPON_MODEL_UNKNOWN
	} ui_model;			/* possibly future use */
	enum ukyopon_port {
		UKYOPON_PORT_UNKNOWN,
		UKYOPON_PORT_MODEM,	/* modem port */
		UKYOPON_PORT_DATA	/* data transfer port */
	} ui_porttype;			/* port type */
	int	ui_rsvd1, ui_rsvd2;
};
#define UKYOPON_NAME		"ukyopon"
.Ed
.Pp
The
.Va ui_name
field contains the driver signature, and has the string
.Dv UKYOPON_NAME .
.Pp
The
.Va ui_busno
field contains the
.Xr usb 4
bus number to which the device is connected;
the
.Va ui_address
field contains the address of the device in the bus.
These fields are useful to identify the physical device
from the file descriptor.
.Pp
The
.Va ui_porttype
field contains the type of device:
.Dv UKYOPON_PORT_MODEM
means the device is associated to the modem port, and
.Dv UKYOPON_PORT_DATA
means the device is associated to the data transfer port.
.Pp
Other fields are reserved for future extension and cleared to zeros.
.El
.Pp
In addition,
.Nm
devices accept all
.Xr ioctl 2
calls that
.Xr umodem 4
accepts.
.Sh SEE ALSO
.Xr tty 4 ,
.Xr ucom 4 ,
.Xr umodem 4 ,
.Xr usb 4 ,
.Pa pkgsrc/comms/kyopon
.Sh HISTORY
The
.Nm
driver
appeared in
.Nx 3.0 .
.Sh NOTES
.Dq Kyopon
is a widely-used nickname of Kyocera AIR-EDGE PHONE.
